=== debian/changelog ===
cataclysm-dda (0.C+git20181202.05d851e-3) unstable; urgency=medium

  * Import upstream patch to address test hangs on some architectures due to
    floating point calculations.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 09 Dec 2018 21:10:43 +0100

cataclysm-dda (0.C+git20181202.05d851e-2) unstable; urgency=medium

  * debian/rules: disable building with ccache again

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 02 Dec 2018 17:34:38 +0100

cataclysm-dda (0.C+git20181202.05d851e-1) unstable; urgency=low

  * New upstream snapshot.
  * Enable Lua support.
    - Build-Depend on liblua5.3-dev and lua5.3
  * Drop reproducible.patch applied upstream.
  * Adapt paths in d/*.install to renamed files.
  * Bump Standards-Version to 4.2.1.
    - Declare that d/rules does not require root

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 02 Dec 2018 16:47:33 +0100
