=== debian/changelog ===
cataclysm-dda (0.C+git20190124.0525397-1) unstable; urgency=medium

  * New upstream snapshot.
  * Drop patch applied upstream.
  * Don't try to run astyle during build.
  * Bump Standards-Version to 4.3.0.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 25 Jan 2019 19:40:33 +0100
