## cataclysm-dda 0.C+git20190228.faafa3a

=== CMakeLists.txt ===
--- 
+++ 
@@ -98,16 +98,6 @@
 		SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libgcc -static-libstdc++")
 	ENDIF(MINGW AND NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
 ENDIF (NOT DYNAMIC_LINKING)
-
-IF(${CMAKE_SYSTEM_NAME} MATCHES Windows)
-	SET(_OS_WINDOWS_ 1)
-	GET_FILENAME_COMPONENT(MINGW_BIN_DIRECTORY ${CMAKE_CXX_COMPILER} PATH)
-	SET(RC_COMPILER_FILENAME "windres.exe")
-	FIND_FILE(RC_COMPILER_PATH ${RC_COMPILER_FILENAME})
-	IF(RC_COMPILER_PATH)
-		MESSAGE(STATUS "Found .rc compiler: ${RC_COMPILER_PATH}")
-	ENDIF(RC_COMPILER_PATH)
-ENDIF(${CMAKE_SYSTEM_NAME} MATCHES Windows)
 
 #Sysem specific actions
 IF (${CMAKE_SYSTEM_NAME} MATCHES Linux OR ${CMAKE_SYSTEM_NAME} MATCHES FreeBSD)
@@ -294,3 +284,12 @@
 	SET(CURSES_NEED_NCURSES TRUE)
 	SET(CURSES_NEED_WIDE TRUE)
 	FIND_PACKAGE(Curses)
+	IF(NOT CURSES_FOUND)
+		MESSAGE(FATAL_ERROR
+			"This project requires ncurses to be installed to be compiled in text only mode. Please install the ncurses development libraries, or try compiling with the -DTILES=1 for a graphical compilation.\nSee INSTALL file for details and more info\n"
+		)
+	ENDIF(NOT CURSES_FOUND)
+ENDIF(CURSES)
+
+IF(SOUND)
+	# You need TILES to be able to use SOUND
