=== debian/changelog ===
cataclysm-dda (0.C+git20190228.faafa3a-2) unstable; urgency=medium

  * Cherry-pick upstream patch to fix sporadic unit test failures.
  * Update upstream changelog.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 01 Mar 2019 18:22:29 +0100

cataclysm-dda (0.C+git20190228.faafa3a-1) unstable; urgency=medium

  * New upstream snapshot.
    - A lot of bugfixes in preparation of 0.D release.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 28 Feb 2019 20:02:49 +0100
