=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                libsdl2-ttf-dev,
                lua5.3,
                pkg-config
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Rules-Requires-Root: no
 Homepage: http://www.cataclysmdda.com/
 Vcs-Git: https://salsa.debian.org/deki-guest/cataclysm-dda.git
