=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 SDL_FLAGS = TILES=1 SOUND=1
 CURSES_FLAGS =
-COMMON_FLAGS = VERSION=$(DEB_VERSION_UPSTREAM) PREFIX=/usr RELEASE=1 USE_XDG_DIR=1 LUA=1 LUA_BINARY=lua5.3 LANGUAGES=all DEBUG_SYMBOLS=1
+COMMON_FLAGS = VERSION=$(DEB_VERSION_UPSTREAM) PREFIX=/usr ASTYLE=0 RELEASE=1 USE_XDG_DIR=1 LUA=1 LUA_BINARY=lua5.3 LANGUAGES=all DEBUG_SYMBOLS=1
 
 # for building with ccache
 #COMMON_FLAGS += CCACHE=1
