=== debian/watch ===
version=4
https://github.com/CleverRaven/Cataclysm-DDA/releases .*/v?@ANY_VERSION@@ARCHIVE_EXT@
